DATABASE stores

GLOBALS

   DEFINE 
      p_customer RECORD LIKE customer.*,
      chosen SMALLINT

END GLOBALS

MAIN

   DEFER INTERRUPT

   OPEN FORM cust_form FROM "customer"

   DISPLAY FORM cust_form

   LET chosen = FALSE

   OPTIONS MESSAGE LINE 22,
      PROMPT LINE 21,
      HELP FILE "custhelp.ex",
      HELP KEY CONTROL-I

   CALL show_menu()

   MESSAGE "End program."

   SLEEP 3

   CLEAR SCREEN

END MAIN


FUNCTION show_menu()

   DEFINE answer  CHAR(1)

   MESSAGE "Type the first letter of the option ",
      "you want to select or CONTROL I for Help."

   MENU "CUSTOMER"
  
   COMMAND "Add" "Add a new customer." HELP 1

      LET answer = "y"

         WHILE answer = "y"

            CALL enter_row()
       
            PROMPT "Do you want to ",
               "enter another row (y/n) ?  "
               FOR CHAR answer

         END WHILE
     
      CLEAR FORM

   COMMAND "Query" "Search for a customer." HELP 2

      CALL query_data()

      IF chosen THEN

         NEXT OPTION "Modify"

      END IF

   COMMAND "Modify" "Modify a customer." HELP 3

      IF chosen THEN

         CALL change_data()

      ELSE

         MESSAGE "No customer has been chosen. ",
            "Use the Query option to select ",
            "a customer."

         NEXT OPTION "Query"

      END IF


   COMMAND "Delete" "Delete a customer." HELP 4

      IF chosen THEN
    
         PROMPT "Are you sure you want to ",
            "delete this customer (y/n)?  "
            FOR CHAR answer

            IF answer = "y" THEN

               CALL delete_row()

             END IF

      ELSE

         MESSAGE "No customer has been chosen. ",
            "Use the Query option to select ",
            "a customer."

         NEXT OPTION "Query"

      END IF


   COMMAND "Exit" "Leave the CUSTOMER menu." HELP 5

      EXIT MENU

   END MENU

END FUNCTION


FUNCTION enter_row()

   LET int_flag = 0

   MESSAGE ""

   CLEAR FORM

   INPUT p_customer.fname THRU p_customer.phone 
      FROM sc_cust.*

   IF int_flag THEN 
      LET int_flag = FALSE
      ERROR "Customer entry aborted."
      RETURN
   END IF

   LET p_customer.customer_num =  0

   INSERT INTO customer VALUES (p_customer.*)

   LET p_customer.customer_num = SQLCA.SQLERRD[2]

   DISPLAY p_customer.customer_num TO customer_num

   MESSAGE "Row added."

   SLEEP 3

   MESSAGE ""

END FUNCTION

    

FUNCTION query_data()

   DEFINE
      where_clause CHAR(200),
      sql_stmt CHAR(250),
      answer CHAR(1),
      exist SMALLINT

   LET int_flag = 0

   MESSAGE ""

   CLEAR FORM


   MESSAGE "Enter search criteria and press ESC."

   SLEEP 3

   MESSAGE ""

   CONSTRUCT where_clause on customer.* FROM customer_num,
      fname, lname, company, address1, address2, city, state,
      zipcode, phone

      IF int_flag THEN 
         LET int_flag = FALSE
         ERROR "Customer query aborted"
         RETURN
      END IF

      LET sql_stmt = "SELECT * FROM customer where ",
         where_clause clipped

   PREPARE ex_sel FROM sql_stmt

   DECLARE q_curs CURSOR FOR ex_sel
                
   LET exist = FALSE

   LET chosen = FALSE

   FOREACH q_curs INTO p_customer.*

      LET exist = TRUE

      DISPLAY BY NAME p_customer.* 
                
      PROMPT "Enter 'y' to select this customer ",
         "or RETURN to view next customer:  "
         FOR CHAR answer

         IF answer = "y" THEN

            LET chosen = TRUE

            EXIT FOREACH

         END IF
               
   END FOREACH

   IF exist = FALSE THEN

      MESSAGE "No customer rows found."

      SLEEP 3

      MESSAGE ""

   ELSE

      IF chosen = FALSE THEN

         MESSAGE "There are no more customer rows."

         SLEEP 3

         MESSAGE ""

         CLEAR FORM

      END IF

   END IF

END FUNCTION


FUNCTION change_data()

   LET int_flag = 0 

   INPUT p_customer.fname THRU p_customer.phone 
      WITHOUT DEFAULTS FROM sc_cust.*

   IF int_flag THEN 
      LET int_flag = FALSE
      ERROR "Customer update aborted."
      RETURN
   END IF

   UPDATE customer 
      SET customer.* = p_customer.*
      WHERE customer_num = p_customer.customer_num

   MESSAGE "Row updated."

   SLEEP 3

   MESSAGE ""

END FUNCTION 


FUNCTION delete_row()

   LET int_flag = 0
 
   DELETE FROM customer WHERE customer_num = 
      p_customer.customer_num

   CLEAR FORM

   MESSAGE "Row deleted."

   SLEEP 3

   MESSAGE ""

END FUNCTION 
