DATABASE leads
GLOBALS "globals.4gl"

MAIN
DEFINE   pa_code           ARRAY[25] OF LIKE product.product_code,
         pa_prod           ARRAY[25] OF LIKE product.description,
         cnt, prod_cnt     SMALLINT

DECLARE c_prod CURSOR FOR
   SELECT      description,
               product_code
      FROM     product
      ORDER BY product_code

LET prod_cnt = 1
FOREACH c_prod                      {Fill pa_prod array.}
   INTO   pa_prod[prod_cnt],
          pa_code[prod_cnt]
   LET prod_cnt = prod_cnt + 1
END FOREACH

INITIALIZE pr_contact.* TO NULL
LET pr_contact.contact_no = 0
LET pr_contact.reference_no = 1     {Set to 1, no-error version only.}
OPEN FORM f_contact FROM "cont_noerr"
DISPLAY FORM f_contact

INPUT BY NAME  pr_contact.cdate THRU pr_contact.contact_type,
               pr_sale.product_code THRU pr_sale.discount

   AFTER FIELD cdate
   {Set and display next contact 2 weeks from this contact.}
      LET pr_contact.next_date = pr_contact.cdate + 14
      DISPLAY BY NAME pr_contact.next_date

   AFTER FIELD employee_no
   {Set and display next employee to current employee}
      LET pr_contact.next_employee = pr_contact.employee_no
      DISPLAY BY NAME pr_contact.next_employee

   BEFORE FIELD contact_type
   {Display instructions for user.}
      MESSAGE "Enter C(complaint) I(request info) Q(inquiry) S(sale)"
         ATTRIBUTE(REVERSE)

   AFTER FIELD contact_type
   {Exit from INPUT if user did not enter "S" }
      MESSAGE ""                                   {Clear message line.       }
      IF (pr_contact.contact_type != "S"
         OR pr_contact.contact_type IS NULL) THEN
         EXIT INPUT
      END IF

   BEFORE FIELD product_code
   {Display instructions for user.}
      MESSAGE "Enter 0 to display and choose from a list of values."
         ATTRIBUTE(REVERSE)

   AFTER FIELD product_code
   {list products if user entered 0 or just pressed RETURN}
      MESSAGE ""                                   {Clear message line.       }
      IF (pr_sale.product_code IS NULL             {See if user just pressed  }
         OR pr_sale.product_code = "0") THEN       {RETURN or entered 0.      }
         CALL SET_COUNT(prod_cnt - 1)              {Set up for DISPLAY ARRAY. }
         MESSAGE "Use ARROW keys to move highlight, ESCAPE to make selection."
            ATTRIBUTE(REVERSE)              {Display message in reverse video.}
         DISPLAY ARRAY pa_prod TO sr_contact_2.*   {Display array on form.    }
         MESSAGE ""                                {Clear message line.       }
         LET cnt = ARR_CURR()               {Determine which item user picked.}
         LET pr_sale.product_code = pa_code[cnt] {record element=array element}
         DISPLAY BY NAME pr_sale.product_code      {Show product code on form.}
         FOR cnt = 1 TO 5
            CLEAR sr_contact_2[cnt].*              {Clear array from form.    }
         END FOR
      END IF

   BEFORE FIELD discount
      MESSAGE "Enter discount as a whole number 0 - 99" ATTRIBUTE(REVERSE)

   AFTER FIELD discount
      MESSAGE ""
      
END INPUT

INSERT INTO contact VALUES (pr_contact.*)    {Insert row into contact table.}
IF (pr_contact.contact_type = "S") THEN      {If it was a sale,}
   LET pr_sale.contact_no = SQLCA.SQLERRD[2] {get serial number assigned by 4GL}
   INSERT INTO sale VALUES (pr_sale.*)       {insert row into sale table.}
END IF

END MAIN
