DATABASE leads
GLOBALS "globals.4gl"

MAIN
DEFINE   pr_sales          RECORD
            tot            MONEY,
            emp            SMALLINT,
            st_date        DATE,
            end_date       DATE
         END RECORD

DECLARE c_sales CURSOR FOR
SELECT      sale.quantity * product.price * (1 - sale.discount/100),
            contact.employee_no
   INTO     pr_sales.tot,
            pr_sales.emp
   FROM     sale,
            product,
            contact
   WHERE    sale.contact_no = contact.contact_no
            AND sale.product_code = product.product_code
            AND contact.cdate BETWEEN pr_sales.st_date AND pr_sales.end_date
   ORDER BY contact.employee_no

PROMPT "Start Date (mm/dd/yy): " FOR pr_sales.st_date
PROMPT "End Date (mm/dd/yy): " FOR pr_sales.end_date
START REPORT medium
FOREACH c_sales
   OUTPUT TO REPORT medium(pr_sales.*)
END FOREACH
FINISH REPORT medium
END MAIN

REPORT medium(prr)
DEFINE   prr               RECORD
            tot            MONEY,
            emp            SMALLINT,
            st_date        DATE,
            end_date       DATE
         END RECORD

OUTPUT
   REPORT TO "medium.out"

FORMAT
PAGE HEADER
   PRINT "Sales Summary by Salesperson"
   PRINT "For the Period ", prr.st_date, " through ", prr.end_date
   SKIP 2 LINES
   PRINT "Employee", COLUMN 20, "Total"
   PRINT "Number", COLUMN 20, "Sales"
   SKIP 1 LINE

AFTER GROUP OF prr.emp
   PRINT prr.emp, COLUMN 15, GROUP SUM(prr.tot) USING "###,##&.&&"

ON LAST ROW
   SKIP 1 LINE
   PRINT "Total", COLUMN 13, SUM(prr.tot) USING "#,###,##&.&&"
END REPORT
