GLOBALS
 "globals.4gl"


MAIN

   DEFER INTERRUPT

   OPEN FORM order_form FROM "orderform"
   DISPLAY FORM order_form
      ATTRIBUTE(MAGENTA)
   MENU "ORDERS"
      COMMAND "Add-order"
      "Enter new order to database"
         CALL add_order()
      COMMAND "Find-order" "Look up and display orders" 
         CALL find_order()
      COMMAND "Exit" "Exit program and return to operating system" 
         CLEAR SCREEN
         EXIT PROGRAM
   END MENU

END MAIN



FUNCTION mess(str, mrow)
   DEFINE str CHAR(80),
      mrow SMALLINT
     
   DISPLAY " ", str CLIPPED AT mrow,1
   SLEEP 3
   DISPLAY "" AT mrow,1
END FUNCTION


FUNCTION clear_menu()

   DISPLAY "" AT 1,1
   DISPLAY "" AT 2,1
END FUNCTION




FUNCTION fetch_stock()

   DECLARE stock_list CURSOR FOR 
   SELECT stock_num, manufact.manu_code,
      manu_name, description, unit_price, unit_descr
      FROM stock, manufact
      WHERE stock.manu_code = manufact.manu_code
      ORDER BY stock_num
   LET stock_cnt = 1
   FOREACH stock_list INTO p_stock[stock_cnt].*
      LET stock_cnt = stock_cnt + 1
   END FOREACH
   LET stock_cnt = stock_cnt - 1
END FUNCTION

FUNCTION query_customer()
   DEFINE where_part CHAR(200),
      query_text CHAR(250),
      answer CHAR(1),
      mrow, chosen, exist SMALLINT

   CLEAR FORM
   CALL clear_menu()

   MESSAGE "Enter criteria for selection"
   CONSTRUCT where_part ON customer.* FROM customer.*
   MESSAGE ""
   IF int_flag THEN
      LET int_flag = FALSE
      CLEAR FORM
      ERROR "Customer query aborted" ATTRIBUTE(RED, REVERSE)
      LET p_customer.customer_num = NULL
      RETURN (p_customer.customer_num)
   END IF
   LET query_text = "select * from customer where ", where_part CLIPPED,
      " order by lname"
   PREPARE statement_1 FROM query_text
   DECLARE customer_set SCROLL CURSOR FOR statement_1

   OPEN customer_set
   FETCH FIRST customer_set INTO p_customer.*
   IF status = NOTFOUND THEN
      LET exist = FALSE
   ELSE
      LET exist = TRUE
      DISPLAY BY NAME p_customer.* ATTRIBUTE(MAGENTA)
      MENU "BROWSE"
         COMMAND "Next" "View the next customer in the list"
            FETCH NEXT customer_set INTO p_customer.*
               IF status = NOTFOUND THEN
                  ERROR "No more customers in this direction"
                     ATTRIBUTE(RED, REVERSE)
                  FETCH LAST customer_set INTO p_customer.*
               END IF
            DISPLAY BY NAME p_customer.*  ATTRIBUTE(MAGENTA)
         COMMAND "Previous" "View the previous customer in the list"
            FETCH PREVIOUS customer_set INTO p_customer.*
               IF status = NOTFOUND THEN
                  ERROR "No more customers in this direction"
                     ATTRIBUTE(RED, REVERSE)
                  FETCH FIRST customer_set INTO p_customer.*
               END IF
            DISPLAY BY NAME p_customer.*  ATTRIBUTE(MAGENTA)
         COMMAND "First" "View the first customer in the list"
            FETCH FIRST customer_set INTO p_customer.*
            DISPLAY BY NAME p_customer.*  ATTRIBUTE(MAGENTA)
         COMMAND "Last" "View the last customer in the list"
            FETCH LAST customer_set INTO p_customer.*
            DISPLAY BY NAME p_customer.*  ATTRIBUTE(MAGENTA)
         COMMAND "Select" "Exit BROWSE selecting the current customer"
            LET chosen = TRUE
            EXIT MENU
         COMMAND "Quit" "Quit BROWSE without selecting a customer"
            LET chosen = FALSE
            EXIT MENU
      END MENU
   END IF
   CLOSE customer_set

   CALL clear_menu()
   IF NOT exist THEN
      CLEAR FORM
      CALL mess("No customer satisfies query", mrow)
      LET p_customer.customer_num = NULL
      RETURN (FALSE)
   END IF
   IF NOT chosen THEN
      CLEAR FORM
      CALL mess("No selection made", mrow)
      LET p_customer.customer_num = NULL
      RETURN (FALSE)
   END IF
   RETURN (TRUE)
END FUNCTION
