GLOBALS
   "globals.4gl"

   DEFINE query_stat INTEGER 


FUNCTION add_order()
   DEFINE pa_curr, s_curr INTEGER

   LET query_stat = query_customer()
   IF query_stat IS NULL OR query_stat = 0 THEN
     RETURN 
   END IF
   DISPLAY by name p_customer.* ATTRIBUTE(CYAN)

   MESSAGE "Enter the order date, PO number and shipping instructions."
   INPUT BY NAME p_orders.order_date, p_orders.po_num,
      p_orders.ship_instruct
   IF int_flag THEN
      LET int_flag = FALSE
      CLEAR FORM
      ERROR "Order input aborted" ATTRIBUTE (RED, REVERSE)
      RETURN
   END IF
   INPUT ARRAY p_items FROM s_items.* 
      BEFORE FIELD stock_num
      MESSAGE "Press ESC to write order"
      DISPLAY "Enter a stock number or press CTRL-B to scan stock list"
         AT 1,1
      BEFORE FIELD manu_code
         MESSAGE "Press ESC to write order"
         DISPLAY "" AT 1, 1
         DISPLAY "Enter a manufacturer code or press CTRL-B to scan ",
            "stock list" at 1, 1
             
      BEFORE FIELD quantity
         MESSAGE "Press ESC to write order"
         DISPLAY "" AT 1,1
         DISPLAY  "Enter the item quantity" AT 1, 1
         ON KEY (CONTROL-B)
            IF INFIELD(stock_num) OR INFIELD(manu_code) THEN
               LET pa_curr = arr_curr()
               LET s_curr = scr_line()
               CALL fetch_stock()
               CALL get_stock() RETURNING 
                 p_items[pa_curr].stock_num, p_items[pa_curr].manu_code, 
                 p_items[pa_curr].description, p_items[pa_curr].unit_price 
               DISPLAY p_items[pa_curr].stock_num
                  TO s_items[s_curr].stock_num
               DISPLAY p_items[pa_curr].manu_code
                  TO s_items[s_curr].manu_code
               DISPLAY p_items[pa_curr].description
                  TO s_items[s_curr].description
               DISPLAY p_items[pa_curr].unit_price
                  TO s_items[s_curr].unit_price
               NEXT FIELD quantity
            END IF
      AFTER FIELD  stock_num, manu_code
         LET pa_curr = arr_curr()
         IF p_items[pa_curr].stock_num IS NOT NULL 
            AND p_items[pa_curr].manu_code IS NOT NULL
         THEN 
            CALL get_item() 
         END IF
           
      AFTER FIELD quantity
         MESSAGE ""
         LET pa_curr = arr_curr()
         IF p_items[pa_curr].unit_price IS NOT NULL
            AND p_items[pa_curr].quantity IS NOT NULL
         THEN
            CALL item_total()
         ELSE
            ERROR "A valid stock code, manufacturer, and ", 
               "quantity must all be entered" ATTRIBUTE (RED, REVERSE)
            NEXT FIELD stock_num
         END IF
      AFTER INSERT, DELETE
         CALL renum_items()
         CALL order_total() 
      AFTER ROW
         CALL order_total()
   END INPUT 

   IF int_flag THEN
      LET int_flag = FALSE
      CLEAR FORM
      ERROR "Order input aborted" ATTRIBUTE (RED, REVERSE)
      RETURN
   END IF

   CALL insert_order()
END FUNCTION

FUNCTION insert_order()
   WHENEVER ERROR CONTINUE
   BEGIN WORK
   INSERT INTO orders (order_num, order_date, customer_num, 
      ship_instruct, po_num)
      VALUES (0, p_orders.order_date, p_customer.customer_num,
         p_orders.ship_instruct, p_orders.po_num)
      IF status < 0 THEN
         ROLLBACK WORK
         ERROR "Unable to complete update of orders table" 
         ATTRIBUTE(RED, REVERSE, BLINK)
         RETURN
      END IF
   LET p_orders.order_num = SQLCA.SQLERRD[2]
   DISPLAY BY NAME p_orders.order_num 
      IF NOT insert_items() THEN
         ROLLBACK WORK
         ERROR "Unable to insert items" ATTRIBUTE(RED, REVERSE, BLINK)
         RETURN
      END IF
   COMMIT WORK
   WHENEVER ERROR STOP
   CALL mess("Order added", 23)
   CLEAR FORM
END FUNCTION


FUNCTION order_total()
   DEFINE order_total MONEY(8),
      i INTEGER

   LET order_total = 0.00
   FOR i = 1 TO arr_count()
      IF p_items[i].total_price IS NOT NULL THEN
         LET order_total = order_total + p_items[i].total_price
      END IF
   END FOR
   LET order_total = 1.1 * order_total
   DISPLAY order_total TO t_price ATTRIBUTE (GREEN)
END FUNCTION


FUNCTION item_total()
   DEFINE pa_curr, sc_curr INTEGER

   LET pa_curr = arr_curr()
   LET sc_curr = scr_line()
   LET p_items[pa_curr].total_price =
      p_items[pa_curr].quantity * p_items[pa_curr].unit_price
   DISPLAY p_items[pa_curr].total_price TO s_items[sc_curr].total_price
END FUNCTION


FUNCTION renum_items()
   DEFINE pa_curr, pa_total, sc_curr, sc_total, k INTEGER

   LET pa_curr = arr_curr()
   LET pa_total = arr_count()
   LET sc_curr = scr_line()
   LET sc_total = 4
   FOR k = pa_curr TO pa_total
      LET p_items[k].item_num = k
      IF sc_curr <= sc_total THEN
         DISPLAY k TO s_items[sc_curr].item_num
         LET sc_curr = sc_curr + 1
      END IF
   END FOR
END FUNCTION


FUNCTION insert_items()
   DEFINE idx INTEGER

   FOR idx = 1 TO arr_count()
      IF p_items[idx].quantity != 0 THEN
         INSERT INTO items 
            VALUES (p_items[idx].item_num, p_orders.order_num,
               p_items[idx].stock_num, p_items[idx].manu_code,
               p_items[idx].quantity, p_items[idx].total_price)
            IF status < 0 THEN
               RETURN (FALSE)
            END IF
      END IF
   END FOR
   RETURN (TRUE)
END FUNCTION


FUNCTION get_stock()
   DEFINE idx integer

   OPEN WINDOW stock_w AT 7, 3
      WITH FORM "stock_sel"
      ATTRIBUTE(BORDER, YELLOW)
   CALL set_count(stock_cnt)
   DISPLAY " Use cursor using F3, F4, and arrow keys; press ESC ",
      "to select a stock item" AT 1,1
   DISPLAY ARRAY p_stock TO s_stock.* 
   LET idx = arr_curr()
   CLOSE WINDOW stock_w
   RETURN p_stock[idx].stock_num, p_stock[idx].manu_code,
      p_stock[idx].description, p_stock[idx].unit_price
END FUNCTION


FUNCTION get_item()
   DEFINE pa_curr, sc_curr INTEGER

   LET pa_curr = arr_curr()
   LET sc_curr = scr_line()
   SELECT description, unit_price
      INTO p_items[pa_curr].description,
         p_items[pa_curr].unit_price
      FROM stock
      WHERE stock.stock_num = p_items[pa_curr].stock_num
         AND stock.manu_code = p_items[pa_curr].manu_code
      IF status THEN
         LET p_items[pa_curr].description = NULL
         LET p_items[pa_curr].unit_price = NULL
      END IF
      DISPLAY p_items[pa_curr].description, p_items[pa_curr].unit_price
         TO s_items[sc_curr].description, s_items[sc_curr].unit_price
      IF p_items[pa_curr].quantity IS NOT NULL THEN
         CALL item_total()
      END IF
END FUNCTION


FUNCTION find_order()
   ERROR "Function not yet implemented"
   SLEEP 3
   RETURN
END FUNCTION
