DATABASE stores

GLOBALS

   DEFINE
      p_customer RECORD LIKE customer.*,
      pa_orders ARRAY[5] OF RECORD
         order_num LIKE orders.order_num,
         order_total MONEY(8)
      END RECORD,

      custnum INTEGER,
      idx INTEGER,
      chosen SMALLINT

END GLOBALS


# Calls get_cust so you can choose a customer; calls get_orders
# if you request an order summary for the customer.

MAIN

   OPTIONS PROMPT LINE 2

   OPEN FORM custmenu FROM "customer"
   DISPLAY FORM custmenu

   LET chosen = FALSE

   MENU "CUSTOMER"

      COMMAND "Select" "Select a customer"

         CALL get_cust()

         IF chosen THEN

              CALL get_orders()

         ELSE
              CLEAR FORM

          END IF

      COMMAND "Exit" "Exit menu."

	 EXIT MENU

   END MENU

END MAIN


# Lets you query for a customer; assigns a value to custnum when you
# request an order summary.

FUNCTION get_cust()

   DEFINE s1, query_1 CHAR(250),
      answer CHAR(1),
      exist SMALLINT

   LET int_flag = 0

   MESSAGE ""
   CLEAR FORM
   MESSAGE "Enter search criteria and press ESCAPE." 

   CONSTRUCT query_1 on customer.* 
      FROM customer.*

   IF int_flag THEN
      LET int_flag = FALSE
      ERROR "Customer query aborted."
   END IF

   LET s1 =" SELECT * FROM customer WHERE ",
      query_1 CLIPPED

   PREPARE query_1 from s1

   DECLARE a_curs CURSOR FOR query_1
 
   LET exist = FALSE
   LET chosen = FALSE

   FOREACH a_curs INTO p_customer.*

      LET exist = TRUE

      DISPLAY BY NAME p_customer.*
      PROMPT "Do you want an order summary for this customer? y/n"
          FOR CHAR answer

      IF answer = "y" THEN

         LET custnum = p_customer.customer_num
         LET chosen = TRUE
         EXIT FOREACH
         RETURN

      END IF

   END FOREACH

   IF exist = FALSE THEN

      MESSAGE "No customer rows found."
      SLEEP 2
      MESSAGE ""
      CLEAR FORM

   ELSE

      IF chosen = FALSE THEN

         MESSAGE "There are no more customer rows."
         SLEEP 2
         CLEAR FORM

      END IF
   END IF

END FUNCTION

# Gets order information for the selected customer.

FUNCTION get_orders()

   DEFINE
      ordnum INTEGER,
      itemtotal MONEY(8),
      svordnum INTEGER,
      ordertotal MONEY(8),
      exist SMALLINT

# Retrieves order numbers and item totals (qty X unit price)

   DECLARE s_curs CURSOR FOR
   SELECT items.order_num, total_price
      FROM customer, orders, items
      WHERE customer.customer_num = orders.customer_num AND
         orders.order_num = items.order_num AND
         orders.customer_num = custnum
         ORDER BY orders.order_num

   LET ordertotal = 0
   LET svordnum = -1
   LET exist = FALSE

   FOREACH s_curs INTO ordnum, itemtotal

      LET exist = TRUE

# tests to see when the current order should be saved

      IF (ordnum = svordnum) THEN
         LET ordertotal= ordertotal + itemtotal
         ELSE
	    IF (svordnum != -1) THEN
	       CALL save_ord(ordnum, ordertotal)
            END IF
         LET svordnum = ordnum
         LET ordertotal = itemtotal
      END IF

   END FOREACH

   IF exist = TRUE THEN

      LET idx = idx - 1
      CALL calc_totals()

   ELSE

      MESSAGE "This customer has no orders."
      SLEEP 2
      MESSAGE ""
      CLEAR FORM

      RETURN

   END IF

END FUNCTION


# Saves order information passed by get_orders

FUNCTION save_ord(svordnum, ordertotal)

   DEFINE
      svordnum INTEGER,
      ordertotal MONEY(8)

   LET pa_orders[idx].order_num = svordnum
   LET pa_orders[idx].order_total = ordertotal
   LET idx  = idx + 1

END FUNCTION


# Computes the total and average of ALL orders

FUNCTION calc_totals()

   DEFINE t_orders MONEY(8),
      avg_orders MONEY(8),
      i INTEGER

   FOR i = 1 to idx
      LET t_orders = t_orders + pa_orders[i].order_total
   END FOR

   LET avg_orders = t_orders/idx

   CALL print_results(t_orders, avg_orders)

END FUNCTION


# Prints the order summary.

FUNCTION print_results(t_orders, avg_orders)

   DEFINE t_orders MONEY(8),
      avg_orders MONEY(8),
      answer CHAR(1),
      i INTEGER
   
   CLEAR SCREEN

   DISPLAY "Customer ", custnum USING "<<<<<", " has the following orders:"
   DISPLAY ""

   FOR i = 1 to idx

     DISPLAY pa_orders[i].*

   END FOR

   DISPLAY ""
   DISPLAY "Total orders: ", t_orders
   DISPLAY "Average amount per order: ", avg_orders
   DISPLAY ""

# Lets you continue or quit the program.

   PROMPT "Press \"c\" to continue or any other key to exit: "
      FOR CHAR answer

      IF answer = "c" THEN
         OPEN FORM custmenu FROM "customer"
         DISPLAY FORM custmenu
      ELSE
         DISPLAY "Program over ..."
         SLEEP 2
         EXIT PROGRAM
      END IF

END FUNCTION

