/***************************************************************************
 *
 *			   INFORMIX SOFTWARE, INC.
 *
 *			      PROPRIETARY DATA
 *
 *	THIS DOCUMENT CONTAINS TRADE SECRET DATA WHICH IS THE PROPERTY OF 
 *	INFORMIX SOFTWARE, INC.  THIS DOCUMENT IS SUBMITTED TO RECIPIENT IN
 *	CONFIDENCE.  INFORMATION CONTAINED HEREIN MAY NOT BE USED, COPIED OR 
 *	DISCLOSED IN WHOLE OR IN PART EXCEPT AS PERMITTED BY WRITTEN AGREEMENT 
 *	SIGNED BY AN OFFICER OF INFORMIX SOFTWARE, INC.
 *
 *	THIS MATERIAL IS ALSO COPYRIGHTED AS AN UNPUBLISHED WORK UNDER
 *	SECTIONS 104 AND 408 OF TITLE 17 OF THE UNITED STATES CODE. 
 *	UNAUTHORIZED USE, COPYING OR OTHER REPRODUCTION IS PROHIBITED BY LAW.
 *
 *
 *  Title:	sqlhdr.h
 *  Sccsid:	@(#)sqlhdr.h	4.10	3/31/87	10:00:27
 *  Description:
 *		header file for all embedded sql programs
 *
 ***************************************************************************
 */

#ifndef _SQLHDR
#define _SQLHDR

#include "sqlda.h"
 

typedef struct 
    {
    short _SQCstmttype;			/* SQ_SELECT, SQ_INSERT, etc. */
    short _SQCsqlid;			/* SQL's id for this cursor */
    short _SQCflags;			/* CROPEN, CREOF, CRSINGLE ,CRPREPARE*/
    short _SQCnfields;			/* number of result fields
					 * (number supplied by SQL)
					 */
    short _SQCnibind;			/* number of input args */
    short _SQCnobind;			/* number of output args */
    short _SQCtupcnt;			/* tuples remaining in buffer */
    short _SQCtupsize;			/* length of data expected from
					 * SQL
					 */
    struct sqlvar_struct *_SQCibind;	/* pointer to first in array of 
					 * binding structures for arguments
					 * to be taken from the user
					 * program and sent to SQL;
					 */
    struct sqlvar_struct *_SQCobind;	/* pointer to first in array of
					 * binding structures for values
					 * to be received from SQL and
					 * supplied to the user program;
					 */
    char **_SQCcommand;			/* pointer to ptrs to pieces of
					 * the command 
					 */
    struct sqlvar_struct *_SQCfields;	/* pointer to first in array of
					 * structures describing the data
					 * to be received from SQL;
					 * (fields described by SQL)
					 */
    char *_SQCstrtab;			/* pointer to table of strings - the
					 * names of the attributes to be
					 * received from SQL
					 * (table supplied by SQL)
					 */
    char *_SQCtbuf;			/* tuple buffer */
    char *_SQCtuple;			/* pointer to current tuple within
					 * buffer
					 */
    char *_SQCname;			/* cursor name */
    struct sqlda  *_SQCsqlda;		/* pointer to sqlda */

		/* used for scroll cursors */
    long _SQCfirst;			/* rowid of 1st tuple in buffer */
    long _SQClast;			/* rowid of last tuple in buffer */
    } _SQCURSOR;


typedef struct 
    {
    short _SQSstmttype;			/* SQ_SELECT, SQ_INSERT, etc. */
    short _SQSsqlid;			/* SQL's id for this cursor */
    } _SQSTMT;

#endif	/* _SQLHDR */
